/*
 * BluSunrize
 * Copyright (c) 2017
 *
 * This code is licensed under "Blu's License of Common Sense"
 * Details can be found in the license file in the root folder of this project
 */

package blusunrize.immersiveengineering.common.gui;

import blusunrize.immersiveengineering.common.util.Utils;
import blusunrize.immersiveengineering.common.util.inventory.IEItemStackHandler;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.inventory.ClickType;
import net.minecraft.inventory.Container;
import net.minecraft.inventory.EntityEquipmentSlot;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;
import net.minecraft.world.World;
import net.minecraftforge.items.CapabilityItemHandler;
import net.minecraftforge.items.IItemHandler;

public abstract class ContainerInternalStorageItem extends Container
{
	protected World world;
	protected int blockedSlot;
	public IItemHandler inv;
	protected EntityEquipmentSlot equipmentSlot = null;
	protected ItemStack heldItem = ItemStack.field_190927_a;
	protected EntityPlayer player = null;
	public final int internalSlots;

	public ContainerInternalStorageItem(InventoryPlayer iinventory, World world, EntityEquipmentSlot entityEquipmentSlot, ItemStack heldItem)
	{
		this.world = world;
		this.player = iinventory.field_70458_d;
		this.equipmentSlot = entityEquipmentSlot;
		this.heldItem = heldItem;
		this.inv = heldItem.getCapability(CapabilityItemHandler.ITEM_HANDLER_CAPABILITY, null);
		if (inv instanceof IEItemStackHandler)
			((IEItemStackHandler) inv).setInventoryForUpdate(iinventory);
		this.internalSlots = this.addSlots(iinventory);
		this.blockedSlot = (iinventory.field_70461_c + 27 + internalSlots);
	}

	abstract int addSlots(InventoryPlayer iinventory);

	@Override
	public ItemStack func_82846_b(EntityPlayer par1EntityPlayer, int slot)
	{
		ItemStack oldStackInSlot = ItemStack.field_190927_a;
		Slot slotObject = field_75151_b.get(slot);

		if(slotObject != null && slotObject.func_75216_d())
		{
			ItemStack stackInSlot = slotObject.func_75211_c();
			oldStackInSlot = stackInSlot.func_77946_l();

			if(slot < internalSlots)
			{
				if(!this.func_75135_a(stackInSlot, internalSlots, (internalSlots + 36), true))
					return ItemStack.field_190927_a;
			}
			else if(allowShiftclicking() && !stackInSlot.func_190926_b())
			{
				boolean b = true;
				for(int i=0; i<internalSlots; i++)
				{
					Slot s = field_75151_b.get(i);
					if(s!=null && s.func_75214_a(stackInSlot))
					{
						if(!s.func_75211_c().func_190926_b() && (!ItemStack.func_179545_c(stackInSlot,s.func_75211_c()) || !Utils.compareItemNBT(stackInSlot,s.func_75211_c())) )
							continue;
						int space = Math.min(s.func_178170_b(stackInSlot), stackInSlot.func_77976_d());
						if(!s.func_75211_c().func_190926_b())
                            space -= s.func_75211_c().func_190916_E();
						if(space <= 0)
							continue;
						ItemStack insert = stackInSlot;
						if(space < stackInSlot.func_190916_E())
							insert = stackInSlot.func_77979_a(space);
						if(this.func_75135_a(insert, i, i + 1, true))
						{
							b = false;
						}
					}
				}
				if(b)
					return ItemStack.field_190927_a;
			}

			if (stackInSlot.func_190916_E() == 0)
				slotObject.func_75215_d(ItemStack.field_190927_a);
			else
				slotObject.func_75218_e();

			slotObject.field_75224_c.func_70296_d();
			if (stackInSlot.func_190916_E() == oldStackInSlot.func_190916_E())
				return ItemStack.field_190927_a;
			slotObject.func_190901_a(player, oldStackInSlot);

			updatePlayerItem();
			func_75142_b();
		}
		return oldStackInSlot;
	}

	protected boolean allowShiftclicking()
	{
		return true;
	}

	@Override
	public boolean func_75145_c(EntityPlayer entityplayer)
	{
		return true;
	}

	@Override
	public ItemStack func_184996_a(int par1, int par2, ClickType par3, EntityPlayer par4EntityPlayer)
	{
		if(par1 == this.blockedSlot || (par3== ClickType.SWAP&&par2==par4EntityPlayer.field_71071_by.field_70461_c))
			return ItemStack.field_190927_a;
		ItemStack ret = super.func_184996_a(par1, par2, par3, par4EntityPlayer);
		updatePlayerItem();
		return ret;
	}

	@Override
	public void func_75134_a(EntityPlayer par1EntityPlayer)
	{
		super.func_75134_a(par1EntityPlayer);
		if (!this.world.field_72995_K)
			updatePlayerItem();
		if (inv instanceof IEItemStackHandler)
			((IEItemStackHandler) inv).setInventoryForUpdate(null);
	}

	protected void updatePlayerItem()
	{
		/*((IInternalStorageItem)this.heldItem.getItem()).setContainedItems(this.heldItem, ((InventoryStorageItem)this.input).stackList);
		ItemStack hand = player.getItemStackFromSlot(this.equipmentSlot);
		if(!hand.isEmpty() && !hand.equals(heldItem))
			player.setItemStackToSlot(this.equipmentSlot, this.heldItem);
		player.inventory.markDirty();TODO remove?*/
	}
}
